(* Time-stamp: <modified the 17/06/2021 (at 15:29) by Erwan Jahier> *)

(** The module is used by
    - the main sasa simulation loop (in ../../src/sasaMain.ml)
    - the RdbgPlugin.t maker (in ../sasa/sasaRun.ml)

*)


   
(* type 'v t = SasArg.t * 'v layout * 'v Env.t *)
type 'v t = {
  sasarg: SasArg.t;
  network: 'v Process.t list;
  neighbors: ('v Register.neighbor list) Map.Make(String).t; (* pid's neigbors *)
  config: 'v Env.t
}

(* [make dynlink_flag argv] *)
val make : bool -> string array -> 'v t

type 'v enable_processes =
  ('v Process.t * 'v Register.neighbor list * Register.action) list list * bool list list
    
val get_enable_processes: 'v t -> 'v enable_processes

(** update the config *)
val update_config: 'v Env.t -> 'v t -> 'v t

(** Get pid's state and neigbors *)
val neigbors_of_pid : 'v t -> string -> 'v * ('v Register.neighbor * string) list

(* For SasaRun *)
val get_inputs_rif_decl : SasArg.t -> 'v Process.t list -> (string * string) list
val get_outputs_rif_decl: SasArg.t -> 'v Process.t list -> (string * string) list
